package progressiveClientServer.gettingBackPrimitive;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.InetSocketAddress;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;

public class ServerCommunicator {

	private static final int SERVER_PORT_NUMBER = 8080;
	private static final int MAX_WAITING_CONNECTIONS = 10;
	
	private HttpServer server;
	
	private ServerCommunicator() {}

	private void run() {

		try {
			server = HttpServer.create(new InetSocketAddress(SERVER_PORT_NUMBER),
											MAX_WAITING_CONNECTIONS);
		} 
		catch (IOException e) {
			System.out.println("Could not create HTTP server: " + e.getMessage());
			e.printStackTrace();
			return;
		}

		server.setExecutor(null); // use the default executor
		
		server.createContext("/", helloWorldHandler);
		
		server.start();
	}
	
	private HttpHandler helloWorldHandler = new HttpHandler() {
		@Override
		public void handle(HttpExchange exchange) throws IOException {
			System.out.println("In hellowWord handler");
			
			PrintWriter printWriter = new PrintWriter(exchange.getResponseBody());
			printWriter.println(true);
			
			// 0 means the response body has an unknown amout of stuff in it
			exchange.sendResponseHeaders(HttpURLConnection.HTTP_OK, 0);
			
			printWriter.close();
		}
	};
	
	public static int getServerPortNumber() {
		return SERVER_PORT_NUMBER;
	}
	
	public static void main(String[] args) {
		new ServerCommunicator().run();
	}

}
