package progressiveClientServer.receiveProxy.handlers;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URI;

import progressiveClientServer.receiveProxy.common.Constants;
import progressiveClientServer.receiveProxy.services.DoubleValueService;

import com.google.gson.Gson;
import com.sun.net.httpserver.Headers;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

public class DoubleValueHandler 
	implements HttpHandler
{
	private static Gson gson = new Gson();
	
	@Override
	public void handle(HttpExchange exchange) throws IOException {
		//Example of how to get information from the headers
		Headers headers = exchange.getRequestHeaders();
		String authorizationCode =
			headers.getFirst(Constants.AUTHORIZATION_KEY);
		System.out.println("The authorization code in doubleValueHandler = " +
			                   authorizationCode);

		//Example of how to get a parameter value from the URI
		URI uri = exchange.getRequestURI();	
		String path = uri.getPath();
		int inputParameter = 5;
		String[] pathParts = path.split("/");
		//pathParts[0].equals("");
		//pathParts[1] should be "double";
		if(pathParts.length > 2) {
			inputParameter = Integer.parseInt(pathParts[2]);
		}
			
		int doubleValue = DoubleValueService.SINGLETON.doubleValue(inputParameter);

		//0 means something is coming back
		exchange.sendResponseHeaders(HttpURLConnection.HTTP_OK, 0);
        OutputStreamWriter outputStreamWriter = 
            new OutputStreamWriter(exchange.getResponseBody());
		gson.toJson(doubleValue, outputStreamWriter);
		outputStreamWriter.close();
	}
}
