package progressiveClientServer.receiveProxy.handlers;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;

import progressiveClientServer.sendAndReceiveProxy.serverSideOnlyClasses.services.NegateValueService;

import com.google.gson.Gson;
import com.sun.net.httpserver.Headers;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

public class NegateValueHandler 
	implements HttpHandler
{
	private static Gson gson = new Gson();
	
	@Override
	public void handle(HttpExchange exchange) throws IOException {	
		//Example of how to get information from the headers
		Headers headers = exchange.getRequestHeaders();
		String authorizationCode = headers.getFirst("authorization");
		System.out.println("The authorization code in negateValueHandler = " + authorizationCode);
		
		double doubleValue  = 10.0d;
		double result = NegateValueService.SINGLETON.negateValue(doubleValue);

		//0 means something is coming back
		exchange.sendResponseHeaders(HttpURLConnection.HTTP_OK, 0);
        OutputStreamWriter outputStreamWriter = 
            new OutputStreamWriter(exchange.getResponseBody());
    	gson.toJson(result, outputStreamWriter);
    	outputStreamWriter.close();
	}
}
